macroScript MultiMatteElement_Generator category:"dPict Tools" tooltip:"MultiMatte Generator"
(
---Start of MaterialStuffer functions By Neil Blevins (neil@soulburn3d.com) http://www.neilblevins.com/blurscripts/blurscripts.htm
global  ms_mats = #()
global  ms_ignore
global  instances_array = #()
global  gb = #()
global  eb = #()

fn materials_in_selected_objects = 
	(
	sel_array = #()
	for i in selection do
		(
		if i.material != undefined then
			(
			if findItem sel_array i.material == 0 then append sel_array i.material
			)
		)
	return sel_array
	)

fn trim_dups a = 
	(
	for i in a.count to 1 by -1 do 
		(
		idx = findItem a a[i]
		if (idx != 0) AND (idx != i) do deleteItem a i
		)
	a
	)

fn copy_from_scene_selection a b = 
		(
		ms_mats = #()
		for i = a to b do
			(
			if i > (materials_in_selected_objects()).count then exit
			else 
				(
				mat_subs = getNumSubMtls (materials_in_selected_objects())[i]				
				if mat_subs == 0 then 
					(	
					append ms_mats (materials_in_selected_objects())[i]
					)else 
					(for m = 1 to mat_subs do
						(					
						temp_mat = (materials_in_selected_objects())[i].materialList[m]
						append ms_mats temp_mat
						)
					)

				)
			)
		)
	
fn lowercase instring =
	(
	upper="ABCDEFGHIJKLMNOPQRSTUVWXYZ"
	lower="abcdefghijklmnopqrstuvwxyz" 
	outstring=copy instring 
	for i = 1 to outstring.count do 
		(
		j=findString upper outstring[i]
		if (j != undefined) do outstring[i]=lower[j]
		)
	outstring
	)
	
fn name_compare_case_insensitive s1 s2 = 
	(
	if (lowercase s1.name) < (lowercase s2.name) then return -1
	else if (lowercase s1.name) > (lowercase s2.name) then return 1
	else return 0
	)

fn get_instances myinput = 
	(
	instances_array = #()
	if (refs.dependents myinput.baseobject).count != 0 then
		(
		for w = 1 to (refs.dependents myinput.baseobject).count do
			(
			if (refs.dependents myinput.baseobject)[w] != myinput then
				(
				if iskindof (refs.dependents myinput.baseobject)[w] (classof myinput) then
					(
					append instances_array (refs.dependents myinput.baseobject)[w]
					)
				)
			)
		)
	return instances_array
	
	)

---End of MaterialStuffer functions By Neil Blevins (neil@soulburn3d.com)


fn get_maxgbuffer a =
	(
	all = geometry
	gb = #()
	for a = 1 to all.count do
		( 
		index = findItem gb (all[a].gbufferChannel)
		if index == 0 then append gb (all[a].gbufferChannel)
		sort gb
		)
		
	return gb
	)
	
fn get_maxMatID a = 
	(
	all = geometry
	ms_mats = #()
	for a = 1 to all.count do
		( 
		
		if all[a].material != undefined then 
			(
			if (classof all[a].material == VRayMtl or classof all[a].material == Standardmaterial or  classof all[a].material == Multimaterial ) then
				( 
				mat_subs = getNumSubMtls all[a].material
				if mat_subs == 0 then 
					(
					index = findItem eb all[a].material.effectsChannel
					if index == 0 then append eb all[a].material.effectsChannel
					)else
					(
					for m = 1 to mat_subs do
						(
						temp_mat = all[a].material.materialList[m]
						index = findItem eb temp_mat.effectsChannel
						if index == 0 then append eb temp_mat.effectsChannel
						)
					)
				)
			)
				
	
		sort eb 
		)
	
	return eb 
	)
	
rollout ro_Mattes "MultiMatteElement Generator v1.0" width:361 height:170
(
	edittext edt1 "Render Element Prefix" pos:[12,13] width:333 height:18 enabled:true 
	button btn1 "Generate" pos:[142,131] width:77 height:30 
	spinner spn1 "Starting G-Buffer/Mat ID" pos:[208,42] width:139 height:16 enabled:false range:[1,25000,1] type:#integer 
	checkbutton mg_material "by Material ID Channel" pos:[12,69] width:126 height:23 toolTip:"MatID is limited to 16 channels (15 materials)"
	checkbox mg_truncate "first 15 materials ONLY!" pos:[12,97] width:147 height:18 enabled:false checked:false
	
	checkbox mg_instances "select and group all instances" pos:[169,67] width:161 height:18 enabled:true checked:true
	checkbutton mg_auto "Autonumber" pos:[12,39] width:126 height:23 toolTip:"" checked:true
	checkbox mg_groupAll "group entire selection" pos:[169,87] width:161 height:18 enabled:true checked:false
	checkbox mg_reset "reset g-buffers to 0 on selected" pos:[169,107] width:178 height:18 enabled:true checked:false
	on btn1 pressed do
	with undo "MME Generator" on

	(
	if selection.count!=0 then (
				
		if edt1.text != "" then reName = edt1.text + "_" else reName = ""
		re = maxOps.GetCurRenderElementMgr()
		el = multimatteelement
		if ( mg_material.state == true) then
			(
				IDStart = spn1.value
				temp_sel = selection as array
				copy_from_scene_selection 1 temp_sel.count 
				if ((ms_mats.count+IDStart)>=16 and mg_truncate.checked==true)then 
					(for extra = 15 to ms_mats.count do
					deleteItem ms_mats 15
					)
				qsort ms_mats name_compare_case_insensitive
				if (ms_mats.count+IDStart)<16 then 
					(
					for i = 1 to ms_mats.count by 3 do
						(
						if ms_mats[i] != undefined then
							(
							ms_mats[i].effectsChannel=i+IDStart-1
							)
						if (i+1<=ms_mats.count) then 
							(if ms_mats[i+1] != undefined then
								(
								ms_mats[i+1].effectsChannel=i+IDStart
								temp_mat1name="," + ms_mats[i+1].name
								)
							)else temp_mat1name = ""
						if (i+2<=ms_mats.count) then 
							(	
							if ms_mats[i+2] != undefined then
								(
								ms_mats[i+2].effectsChannel=i+1+IDStart
								temp_mat2name="," + ms_mats[i+2].name
								)
							)else temp_mat2name=""
						re.addrenderelement (el elementname:(reName + ms_mats[i].name + temp_mat1name + temp_mat2name) R_gbufID:(i+IDStart-1) R_gbufIDOn:(on) G_gbufID:(i+IDStart) G_gbufIDOn:(on) B_gbufID:(i+IDStart+1) B_gbufIDOn:(on) MatID:(on))
						)
					)else 
					(
					mb = "MatID is limited to maximum of 15 ("+ ms_mats.count as string + " selected)\nreduce number of materials (including multi/sub)\nor starting ID (currently "+IDStart as string +")"
					messagebox mb
					)
		
		
			)
			else
			(
			    IDStart = spn1.value
				if mg_auto.checked==true then 
					(
					get_maxgbuffer objs
					try (if gb.count != 0 then IDStart = gb[gb.count]+1) catch (IDStart-1)
					)
				objs = selection as array
			    el=multimatteelement
			    count= objs.count 
				qsort objs name_compare_case_insensitive
				name1=""
				name2=""
				name3=""
			    
			    if mg_reset.checked==true then 
					(
				    for i = 1 to count do
						(
						if objs[i] != undefined then 
							(
							get_instances objs[i]
							objs[i].gbufferChannel=0
							if instances_array.count>0 and mg_instances.checked==true  then 
								(
								for ia = 1 to (instances_array.count) do
									(
									instances_array[ia].gbufferChannel=0
									index = findItem objs instances_array[ia]
									if index !=0 then deleteItem objs index
									)
								)
							)
						)
					)else
					(
					If mg_groupAll.checked==true then 
						(
					    for i = 1 to count do
							(
							if objs[i] != undefined then 
								(
								objs[i].gbufferChannel=IDStart
								)
							)
						name1=objs[1].name +"..."
						re.addrenderelement (el elementname:(reName + name1) R_gbufID:(IDStart) R_gbufIDOn:(on) G_gbufIDOn:(off) B_gbufIDOn:(off) )
							
						)else
						(
					    For i = 1 to count by 3 do
					        (	if objs[i] != undefined then 
										(
										get_instances objs[i]
										print instances_array
										objs[i].gbufferChannel=i+IDStart-1 
										if instances_array.count>0 and mg_instances.checked==true  then 
											(for ia = 1 to (instances_array.count) do
												(
												instances_array[ia].gbufferChannel=i+IDStart-1 
												index = findItem objs instances_array[ia]
												if index !=0 then deleteItem objs index
												)
											objs[i].gbufferChannel=i+IDStart-1
											name1=objs[i].name
											) else (objs[i].gbufferChannel=i+IDStart-1)
										name1=objs[i].name
									)else exit
									
									
					                if objs[i+1] != undefined then 
										(get_instances objs[i+1]
										if instances_array.count>0 and mg_instances.checked==true then 
											(for ia = 1 to (instances_array.count) do
													(
													instances_array[ia].gbufferChannel=i+IDStart
													index = findItem objs instances_array[ia]
													if index !=0 then deleteItem objs index
													)
												objs[i+1].gbufferChannel=i+IDStart
												name2=","+ objs[i+1].name
											) else (objs[i+1].gbufferChannel=i+IDStart)
											name2=","+objs[i+1].name
										)else name2=""
									
					                if objs[i+2] != undefined then 
										(
										get_instances objs[i+2]
										if instances_array.count>0 and mg_instances.checked==true then 
											(for ia = 1 to (instances_array.count) do
													(
													instances_array[ia].gbufferChannel=i+IDStart+1 
													index = findItem objs instances_array[ia]
													if index !=0 then deleteItem objs index
													)
												objs[i+2].gbufferChannel=i+IDStart+1
												name3=","+objs[i+2].name
											) else (objs[i+2].gbufferChannel=i+IDStart+1)
											name3=","+objs[i+2].name
										)else name3=""
				
					                re.addrenderelement (el elementname:(reName + name1 + name2 + name3) R_gbufID:(i+IDStart-1) R_gbufIDOn:(on) G_gbufID:(i+IDStart) G_gbufIDOn:(on) B_gbufID:(i+IDStart+1) B_gbufIDOn:(on) )
					                
					        )
						)
					)	
			)
		)
		else messagebox "Pick something!"
	)
		
	on mg_material changed state do
	(if state==on then 
	(
		spn1.range = [1,15,1] 
		mg_truncate.enabled=true
		mg_instances.enabled=false
		global autocheck
		autocheck = mg_auto.checked
		mg_auto.checked=false
		mg_auto.enabled=false
		mg_groupAll.enabled=false
	mg_reset.enabled=false
	
	)
	else 
	(
		spn1.range = [1,100,1]
		mg_truncate.enabled=false
		if mg_groupAll.checked == false then mg_instances.enabled=true else  mg_instances.enabled=false
		if mg_reset.checked==true then 
			(
			
			mg_auto.checked=autocheck
			mg_auto.enabled=false
			mg_groupAll.enabled=false
			mg_reset.enabled=true
			)	
			else
			(
			
			mg_auto.checked=autocheck
			mg_auto.enabled=true
			mg_groupAll.enabled=true
			mg_reset.enabled=true
			)
			
	)
		
	)
	on mg_auto changed state do
		(if mg_auto.checked==true then spn1.enabled = false else spn1.enabled=true)
	on mg_groupAll changed state do
		(if mg_groupAll.checked==true then (mg_instances.enabled = false) else (mg_instances.enabled = true))
	on mg_reset changed state do
	(if mg_reset.checked==true then 
		(
		mg_instances.enabled = true
		mg_groupAll.enabled=false
		spn1.enabled=false
		global autocheck
		autocheck = mg_auto.checked
		mg_auto.checked=false
		mg_auto.enabled=false
		) 
		else 
		(
		if mg_groupAll.checked==false then (mg_instances.enabled = true)else (mg_instances.enabled = false)
		mg_groupAll.enabled=true
		mg_auto.checked=autocheck
		mg_auto.enabled=true
	
		if autocheck==false then spn1.enabled=true else spn1.enabled=false
		)
	)
)


createDialog ro_Mattes 361 170 modal:false

)
